<script setup lang="ts">
import { ref, computed, defineProps, defineEmits } from 'vue';

// Props
const props = defineProps<{
  totalPages: number;
  currentPage: number;
}>();

const emit = defineEmits<{
  (e: 'pageChange', page: number): void;
}>();

const maxVisiblePages = 10;
const showLeftEllipsis = ref(false);
const showRightEllipsis = ref(false);

const pages = computed(() => {
  const startPage = Math.max(1, props.currentPage - Math.floor(maxVisiblePages / 2));
  const endPage = Math.min(props.totalPages, startPage + maxVisiblePages - 1);

  const range = [];
  for (let i = startPage; i <= endPage; i++) {
    range.push({ name: i, isDisabled: i === props.currentPage });
  }

  return range;
});

watchEffect(() => {
  const startPage = Math.max(1, props.currentPage - Math.floor(maxVisiblePages / 2));
  const endPage = Math.min(props.totalPages, startPage + maxVisiblePages - 1);

  showLeftEllipsis.value = startPage > 1;
  showRightEllipsis.value = endPage < props.totalPages;
});

const isInFirstPage = computed(() => props.currentPage === 1);
const isInLastPage = computed(() => props.currentPage === props.totalPages);

// Methods
const onClickPreviousPage = () => {
  if (!isInFirstPage.value) {
    emit('pageChange', props.currentPage - 1);
  }
};

const onClickPage = (page: number) => {
  if (page !== props.currentPage) {
    emit('pageChange', page);
  }
};

const onClickNextPage = () => {
  if (!isInLastPage.value) {
    emit('pageChange', props.currentPage + 1);
  }
};

const isPageActive = (page: number) => props.currentPage === page;
</script>

<template>
  <div class="pagination">
    <ul>
      <li v-if="!isInFirstPage && totalPages !== 0">
        <SlpButton variant="secondary" :disabled="isInFirstPage" @click="onClickPreviousPage">
          <SlpIcon class="slp-mr-8" name="chevron-lg-left" variant="product" />
          Previous
        </SlpButton>
      </li>
      <li v-if="showLeftEllipsis">
        <SlpButton variant="secondary" :disabled="true"> ... </SlpButton>
      </li>
      <li v-for="page in pages" :key="page.name">
        <SlpButton
          variant="secondary"
          :disabled="page.isDisabled"
          :class="{ 'pagination--active': isPageActive(page.name) }"
          @click="!page.isDisabled && onClickPage(page.name)"
        >
          {{ page.name }}
        </SlpButton>
      </li>
      <li v-if="showRightEllipsis">
        <SlpButton variant="secondary" :disabled="true"> ... </SlpButton>
      </li>
      <li v-if="!isInLastPage && totalPages !== 0">
        <SlpButton variant="secondary" :disabled="isInLastPage" @click="onClickNextPage">
          Next
          <SlpIcon class="slp-ml-8" name="chevron-lg-right" variant="product" />
        </SlpButton>
      </li>
    </ul>
  </div>
</template>

<style scoped lang="scss">
.pagination {
  display: flex;
  justify-content: center;
  padding: $spacing-24;

  &--active {
    background-color: $color-surface-800 !important;
    color: $color-primary-200 !important;
  }

  ul {
    display: flex;
    flex-wrap: wrap;
    .slp-btn {
      justify-content: center;
      padding: $spacing-4 12px;
      margin: 0;
      min-width: unset;

      &:not(.slp-btn-disabled) {
        color: $color-surface-700;
      }

      &:hover:not(.slp-btn-disabled) {
        background-color: #e3d6ff;
      }
    }
  }
}
</style>
